<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <meta name="author" content="Iker Landajuela">
  <link rel="shortcut icon" href="../../../favicon.ico">
  
  <title>Tutorial:  Simple Reddit clone - Programación con Angular</title>
  <link href='https://fonts.googleapis.com/css?family=Lato:400,700|Roboto+Slab:400,700|Inconsolata:400,700' rel='stylesheet' type='text/css'>

  <link rel="stylesheet" href="../../../css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../css/theme_extra.css" type="text/css" />
  <link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css">
  
  <script>
    // Current page data
    var mkdocs_page_name = "Tutorial:  Simple Reddit clone";
    var mkdocs_page_input_path = "intro\\reddit-clone\\reddit-clone.md";
    var mkdocs_page_url = "/angular/intro/reddit-clone/reddit-clone/";
  </script>
  
  <script src="../../../js/jquery-2.1.1.min.js" defer></script>
  <script src="../../../js/modernizr-2.8.3.min.js" defer></script>
  <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
  <script>hljs.initHighlightingOnLoad();</script> 
  
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
      <div class="wy-side-nav-search">
        <a href="../../.." class="icon icon-home"> Programación con Angular</a>
        <div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
	<ul class="current">
	  
          
            <li class="toctree-l1">
		
    <a class="" href="../../..">Introducción</a>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Conceptos básicos</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../../conceptos/componentes/componentes/">Componentes</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../conceptos/data-binding/data-binding/">Binding</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../conceptos/directivas/directivas/">Directivas</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../conceptos/routing/proyecto-basico-routing/proyecto-basico-routing/">Routing</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../conceptos/http/consumir-servicios-api-rest/consumir-servicios-api-rest/">Consumir servicios REST</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../conceptos/estilos/instalar-bootstrap/instalar-bootstrap/">Introducción Bootstrap</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Proyectos</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../getting-started/getting-started/">Mi primera aplicación</a>
                </li>
                <li class="">
                    
    <a class="" href="../../flujo-de-una-app/flujo-de-una-app/">Flujo de una aplicación</a>
                </li>
                <li class="">
                    
    <a class="" href="../../todo-aplicacion-lista-tareas/todo-aplicacion-lista-tareas/">Aplicación lista de tareas</a>
                </li>
                <li class=" current">
                    
    <a class="current" href="./">Tutorial:  Simple Reddit clone</a>
    <ul class="subnav">
            
    <li class="toctree-l3"><a href="#introduccion">Introducción</a></li>
    

    <li class="toctree-l3"><a href="#creacion-del-proyecto">Creación del proyecto</a></li>
    

    <li class="toctree-l3"><a href="#creando-un-componente">Creando un componente</a></li>
    

    <li class="toctree-l3"><a href="#cargando-nuestro-componente">Cargando nuestro componente</a></li>
    

    <li class="toctree-l3"><a href="#anadiendo-datos-al-componente">Añadiendo datos al componente</a></li>
    

    <li class="toctree-l3"><a href="#trabajando-con-arreglos">Trabajando con arreglos</a></li>
    

    <li class="toctree-l3"><a href="#usando-el-useritemcomponent">Usando el UserItemComponent</a></li>
    

    <li class="toctree-l3"><a href="#aceptando-entradas">Aceptando entradas</a></li>
    

    <li class="toctree-l3"><a href="#pasando-un-valor-de-entrada">Pasando un valor de entrada</a></li>
    

    <li class="toctree-l3"><a href="#ejecucion-de-la-aplicacion">Ejecución de la aplicación</a></li>
    

    <li class="toctree-l3"><a href="#expandiendo-nuestra-aplicacion">Expandiendo nuestra aplicación</a></li>
    

    <li class="toctree-l3"><a href="#anadiendo-accion-al-formulario">Añadiendo acción al formulario</a></li>
    

    <li class="toctree-l3"><a href="#anadiendo-el-componente-con-el-articulo">Añadiendo el componente con el artículo</a></li>
    

    <li class="toctree-l3"><a href="#renderizando-una-serie-de-articulos">Renderizando una serie de artículos</a></li>
    
        <ul>
        
            <li><a class="toctree-l4" href="#creando-una-clase-para-los-articulos">Creando una clase para los artículos</a></li>
        
        </ul>
    

    <li class="toctree-l3"><a href="#almacenando-mas-de-un-articulo">Almacenando más de un artículo</a></li>
    

    <li class="toctree-l3"><a href="#codigo-fuente">Código fuente</a></li>
    

    <li class="toctree-l3"><a href="#enlaces-externos">Enlaces externos</a></li>
    

    </ul>
                </li>
                <li class="">
                    
    <a class="" href="../../ejercicio-gestion-clientes/ejercicio-gestion-clientes/">Aplicación: Gestión clientes</a>
                </li>
                <li class="">
                    
    <a class="" href="../../tour-of-heroes/tour-of-heroes/">Tutorial: Tour of Heroes</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Módulos</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../../modulos/rxjs/rxjs/">Programación reactiva RxJS</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Formularios</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../../ui/forms/basic-form/basic-form/">Formulario básico (Reactive)</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../ui/forms/basic-form-validation/basic-form-validation/">Validación básica formulario (Reactive)</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Componentes UI</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../../ui/primeng/primeng/">PrimeNG</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Otros</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../../otros/json-server/json-server/">JSON-Server NodeJS</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <a class="" href="../../../recursos/recursos/">Recursos</a>
	    </li>
          
        </ul>
      </div>
      &nbsp;
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../..">Programación con Angular</a>
      </nav>

      
      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../..">Docs</a> &raquo;</li>
    
      
        
          <li>Proyectos &raquo;</li>
        
      
    
    <li>Tutorial:  Simple Reddit clone</li>
    <li class="wy-breadcrumbs-aside">
      
        <a href="https://gitlab.com/soka/angular/edit/master/docs/intro/reddit-clone/reddit-clone.md"
          class="icon icon-gitlab"
        > Edit on GitLab</a>
      
    </li>
  </ul>
  <hr/>
</div>
          <div role="main">
            <div class="section">
              
                <div class="toc">
<ul>
<li><a href="#introduccion">Introducción</a></li>
<li><a href="#creacion-del-proyecto">Creación del proyecto</a></li>
<li><a href="#creando-un-componente">Creando un componente</a></li>
<li><a href="#cargando-nuestro-componente">Cargando nuestro componente</a></li>
<li><a href="#anadiendo-datos-al-componente">Añadiendo datos al componente</a></li>
<li><a href="#trabajando-con-arreglos">Trabajando con arreglos</a></li>
<li><a href="#usando-el-useritemcomponent">Usando el UserItemComponent</a></li>
<li><a href="#aceptando-entradas">Aceptando entradas</a></li>
<li><a href="#pasando-un-valor-de-entrada">Pasando un valor de entrada</a></li>
<li><a href="#ejecucion-de-la-aplicacion">Ejecución de la aplicación</a></li>
<li><a href="#expandiendo-nuestra-aplicacion">Expandiendo nuestra aplicación</a></li>
<li><a href="#anadiendo-accion-al-formulario">Añadiendo acción al formulario</a></li>
<li><a href="#anadiendo-el-componente-con-el-articulo">Añadiendo el componente con el artículo</a></li>
<li><a href="#renderizando-una-serie-de-articulos">Renderizando una serie de artículos</a><ul>
<li><a href="#creando-una-clase-para-los-articulos">Creando una clase para los artículos</a></li>
</ul>
</li>
<li><a href="#almacenando-mas-de-un-articulo">Almacenando más de un artículo</a></li>
<li><a href="#codigo-fuente">Código fuente</a></li>
<li><a href="#enlaces-externos">Enlaces externos</a></li>
</ul>
</div>
<h1 id="introduccion">Introducción</h1>
<p>En esta ocasión vamos a desarrollar una aplicación que permita al usuario postear un artículo (título y URL)
y votar entre todos los posts.</p>
<p>Técnicas que aprenderemos desarrollando el ejercicio:</p>
<ul>
<li>Construir <strong>componentes</strong> nuevos.</li>
<li>Procesar la entrada del usuario en un <strong>formulario</strong>.</li>
<li>Renderizar una serie de <strong>objetos en una vista</strong>.</li>
<li><strong>Capturar los eventos</strong> de pulsación del ratón del usuario y procesarlos.</li>
</ul>
<h1 id="creacion-del-proyecto">Creación del proyecto</h1>
<p>Seguimos siempre los mismos pasos para construir la estructura de proyecto y ejecutar nuestra aplicación en el navegador:</p>
<pre><code class="JS">ng new reddit-clone
cd reddit-clone
ng serve --open
</code></pre>

<p>Si el puerto por defecto está ocupado por otro servicio podemos especificar otro con <code>--port 9001</code>, por defecto arranca el servidor local de desarrollo en el puerto 4200.</p>
<h1 id="creando-un-componente">Creando un componente</h1>
<p>Una de las características más destacadas de <strong>Angular</strong> son los componentes Web.</p>
<pre><code class="JS">ng generate component reddit-clone
</code></pre>

<p>Podemos usar la sintaxis abreviada para hacer lo mismo <code>ng g c reddit-clone</code>.</p>
<p>Ahora tenemos una nueva ruta y varios ficheros del componente ya creados en [reddit-clone/src/app/reddit-clone]:</p>
<p><img alt="" src="../img/01.PNG" /></p>
<p>El componente TypeScript (extensión .ts) "reddit-clone.component.ts" tiene dos secciones principales:</p>
<ul>
<li>El decorador del componente.</li>
<li>Definición de la clase del componente, en este caso la clase se llamará <code>RedditCloneComponent</code>.</li>
</ul>
<pre><code class="JS">import { Component, OnInit } from '@angular/core';

@Component({
  selector: 'app-reddit-clone',
  templateUrl: './reddit-clone.component.html',
  styleUrls: ['./reddit-clone.component.css']
})
export class RedditCloneComponent implements OnInit {

  constructor() { }

  ngOnInit() {
  }

}
</code></pre>

<p>La sentencia <code>import</code> define los <strong>módulos</strong> que queremos usar (<code>Component</code> y <code>OnInit</code>) de la ruta <code>@angular/core</code>.</p>
<p>Después definimos el <strong>decorador</strong>, es algo así como los metadatos del componente. Con el selector le decimos que queremos usar una etiqueta <code>&lt;app-reddit-clone&gt;&lt;/app-reddit-clone&gt;</code>.</p>
<p>La siguiente parte es definir que plantilla queremos usar con <code>templateUrl</code>, en este caso es "reddit-clone.component.html":</p>
<pre><code class="HTML">&lt;p&gt;
  reddit-clone works!
&lt;/p&gt;
</code></pre>

<p>Si en vez de usar <code>templateUrl</code> usamos <code>template</code> podemos definir la plantilla dentro del propio decorador como sigue:</p>
<pre><code class="JS">@Component({
  selector: &quot;app-reddit-clone&quot;,
  template: `
  &lt; p &gt;
      Works inline!
  &lt;/p&gt;
  `
})
</code></pre>

<p>Usamos "`" para definir una cadena formada por varias líneas.</p>
<p>Con el último parámetro definimos la hoja de estilos CSS del componente.</p>
<h1 id="cargando-nuestro-componente">Cargando nuestro componente</h1>
<p>Para cargar el componente editamos "app.component.html", reemplazamos todo el contenido por este:</p>
<pre><code class="JS">&lt;h1&gt;
  {{ title }}
  &lt;app-reddit-clone&gt;&lt;/app-reddit-clone&gt;
&lt;/h1&gt;
</code></pre>

<p><img alt="" src="../img/02.PNG" /></p>
<h1 id="anadiendo-datos-al-componente">Añadiendo datos al componente</h1>
<p>Hasta el momento nuestro componente solo renderiza una plantilla estática. Imaginemos que queremos mostrar una lista de usuarios y sus nombres.</p>
<pre><code class="JS">ng generate component user-item
</code></pre>

<p>Para poder usarlo debemos añadir la nueva etiqueta <code>&lt;app-user-item&gt;&lt;/app-user-item&gt;</code> a "app.component.html".</p>
<p>Queremos usar el nuevo componente para mostrar un nombre de usuario, añadimos una nueva propiedad de tipo cadena (<em>string</em>) a la clase y la rellenamos en el constructor:</p>
<pre><code class="JS">export class UserItemComponent implements OnInit {
  name: string; // &lt;-- added name property

  constructor() {
    this.name = &quot;Felipe&quot;; // set the name
  }

  ngOnInit() {}
}
</code></pre>

<p>Ahora vamos a renderizar la plantilla mostrando el nombre, modificamos "user-item.component.html":</p>
<pre><code class="JS">&lt;p&gt;Hello {{ name }}&lt;/p&gt;
</code></pre>

<p>La sintaxis "{{}}" para definir una expresión se conoce como <em>template tags</em> o <em>mustache tags</em>.</p>
<p><img alt="" src="../img/03.PNG" /></p>
<h1 id="trabajando-con-arreglos">Trabajando con arreglos</h1>
<p>Queremos mostrar los nombres de una serie de usuarios, creamos un nuevo componente:</p>
<pre><code class="JS">ng generate component user-list
</code></pre>

<p>Como en las anteriores ocasiones añadimos <code>&lt;app-user-list&gt;&lt;/app-user-list&gt;</code> a "app.component.html".</p>
<p>Modificamos la definición de la clase del nuevo componente, añadimos un array de cadenas como propiedad de la clase</p>
<pre><code class="JS">export class UserListComponent implements OnInit {
  names: string[];

  constructor() {
    this.names = [&quot;Ari&quot;, &quot;Carlos&quot;, &quot;Felipe&quot;, &quot;Nate&quot;];
  }

  ngOnInit() {}
}
</code></pre>

<p>Para recorrer el array usaremos un bucle for <code>*ngFor</code> en "user-list-component.html":</p>
<pre><code class="JS">&lt;ul&gt;
  &lt;li *ngFor=&quot;let name of names&quot;&gt;Hello {{ name }}&lt;/li&gt;
&lt;/ul&gt;
</code></pre>

<p><img alt="" src="../img/04.PNG" /></p>
<h1 id="usando-el-useritemcomponent">Usando el UserItemComponent</h1>
<p>En vez de declarar el array dentro de la clase <code>UserListComponent</code> usaremos la clase <code>UserItemComponent</code> como un elemento hijo.</p>
<p>Pasos:</p>
<ul>
<li>Configurar la plantilla <code>UserListComponent</code>.</li>
<li>Configurar <code>UserItemComponent</code> para aceptar el nombre como una entrada.</li>
<li>Configurar <code>UserItemComponent</code> para que acepte el atributo nombre como entrada en el constructor.</li>
</ul>
<p>Modificamos la plantilla "user-list.component.html", en cada iteración del bucle que recorre los elementos array carga el componente <code>UserItemComponent</code>.</p>
<pre><code class="JS">&lt;ul&gt;
  &lt;li *ngFor=&quot;let name of names&quot;&gt;
    &lt;app-user-item&gt;&lt;/app-user-item&gt;
  &lt;/li&gt;
&lt;/ul&gt;
</code></pre>

<p>Ahora veremos esto en el navegador:</p>
<p><img alt="" src="../img/05.PNG" /></p>
<p>El bucle <code>*ngFor</code> recorre los elementos del array atributo de <code>UserListComponent</code> pero carga el componente <code>&lt;p&gt;Hello {{ name }}&lt;/p&gt;</code> mostrando el atributo cadena de la clase <code>UserItemComponent</code>.</p>
<p>Debemos pasarle de alguna manera los datos de entrada al componente <code>UserItemComponent</code>, en <strong>Angular</strong> usamos el decorador <code>@Input</code>.</p>
<h1 id="aceptando-entradas">Aceptando entradas</h1>
<p>Hasta el momento el constructor de la clase <code>UserItemComponent</code> fijaba el atributo con el nombre (<code>this.name = "Felipe";</code>), vamos a modificarlo para que acepte el valor de esta propiedad.</p>
<pre><code class="ts">import {
  Component,
  OnInit,
  Input // &lt;--- added this
} from &quot;@angular/core&quot;;

@Component({
  selector: &quot;app-user-item&quot;,
  templateUrl: &quot;./user-item.component.html&quot;,
  styleUrls: [&quot;./user-item.component.css&quot;]
})
export class UserItemComponent implements OnInit {
  @Input() name: string; // &lt;-- added Input annotation

  constructor() {
    // removed setting name
  }

  ngOnInit() {}
}
</code></pre>

<h1 id="pasando-un-valor-de-entrada">Pasando un valor de entrada</h1>
<p>Para pasar valores a un componente usamos "[]" en la plantilla:</p>
<pre><code class="ts">&lt;ul&gt;
  &lt;li *ngFor=&quot;let individualUserName of names&quot;&gt;
    &lt;app-user-item [name]=&quot;individualUserName&quot;&gt;&lt;/app-user-item&gt;
  &lt;/li&gt;
&lt;/ul&gt;
</code></pre>

<p><img alt="" src="../img/06.PNG" /></p>
<h1 id="ejecucion-de-la-aplicacion">Ejecución de la aplicación</h1>
<p>Cuando ejecutamos <code>ng serve</code> sucede lo siguiente:</p>
<p>ng busca en "angular.json" el punto de entrada a la aplicación, en este caso es <code>"main": "src/main.ts"</code>, este a su vez usa <code>AppModule</code> definido en [src/app/app.module.ts]:</p>
<p>El módulo <code>app</code> también se conoce como módulo raíz porque de él surgen las demás ramas que conforman una aplicación. La asignación de los nodos hijos se realiza en la propiedad <code>imports:[]</code>, que es un array de punteros a otros módulos.</p>
<pre><code class="ts">import { BrowserModule } from &quot;@angular/platform-browser&quot;;
import { NgModule } from &quot;@angular/core&quot;;

import { AppComponent } from &quot;./app.component&quot;;
import { RedditCloneComponent } from &quot;./reddit-clone/reddit-clone.component&quot;;
import { UserItemComponent } from &quot;./user-item/user-item.component&quot;;
import { UserListComponent } from &quot;./user-list/user-list.component&quot;;

@NgModule({
  declarations: [
    AppComponent,
    RedditCloneComponent,
    UserItemComponent,
    UserListComponent
  ],
  imports: [BrowserModule],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule {}
</code></pre>

<p>El decorador <code>@NgModule</code> añade los metatados de la clase <code>AppModule</code> que va después y está compuesto por cuatro claves:</p>
<ul>
<li><code>declarations</code>: Declara los componentes de nuestra aplicación. Cuando añadimos nuevos componentes con <code>ng generate</code> estos se añaden de forma automática a esta información.</li>
<li><code>imports</code>: Describe las dependencias del módulo. Como estamos creando una aplicación Web usamos <code>BrowserModule</code>.</li>
<li><code>providers</code>: Se usa para inyección de dependencias.</li>
<li><code>bootstrap</code>: Le dice a <strong>Angular</strong> que componente usa para arrancar la aplicación, <code>AppComponent</code> es el componente de nivel superior.</li>
</ul>
<h1 id="expandiendo-nuestra-aplicacion">Expandiendo nuestra aplicación</h1>
<p>Ahora vamos a crear la aplicación final, esta compuesta por dos componentes lógicos.</p>
<ol>
<li>La aplicación completa que contiene el formulario para dar de alta nuevos artículos (en una versión más avanzada lo lógico sería que el formulario tuviese su propio componente).</li>
<li>Cada uno de los artículos en una lista.</li>
</ol>
<p>Creamos una nueva aplicación:</p>
<pre><code class="ts">ng new angular-reddit
</code></pre>

<p>Empezamos como siempre por [angular-reddit/src/app/app.component.ts]:</p>
<pre><code class="ts">import { Component } from &quot;@angular/core&quot;;

@Component({
  selector: &quot;app-root&quot;,
  templateUrl: &quot;./app.component.html&quot;,
  styleUrls: [&quot;./app.component.css&quot;]
})
export class AppComponent {
  //title = 'angular-reddit'; // &lt;--- Comentado
}
</code></pre>

<p>Comentamos el título.</p>
<p>Editamos [angular-reddit/src/app/app.component.html]:</p>
<pre><code class="ts">&lt;form&gt;
  &lt;h3&gt;Add a Link&lt;/h3&gt;

  &lt;div&gt;
    &lt;label for=&quot;title&quot;&gt;Title:&lt;/label&gt;
    &lt;input name=&quot;title&quot; id=&quot;title&quot; /&gt;
  &lt;/div&gt;

  &lt;div&gt;
    &lt;label for=&quot;link&quot;&gt;Link:&lt;/label&gt;
    &lt;input name=&quot;link&quot; id=&quot;link&quot; /&gt;
  &lt;/div&gt;
&lt;/form&gt;
</code></pre>

<p>Hemos creado el formulario para introducir el título y el enlace de un artículo.</p>
<p><img alt="" src="../img/07.PNG" /></p>
<h1 id="anadiendo-accion-al-formulario">Añadiendo acción al formulario</h1>
<p>Añadimos un botón para procesar el formulario de arriba:</p>
<pre><code class="ts">&lt;button (click)=&quot;addArticle(newtitle, newlink)&quot;&gt;Submit link&lt;/button&gt;
</code></pre>

<p>Ahora cuando se pulse el botón ejecuta una función <code>addArticle</code> que debemos definir en el componente, entonces añadimos a la clase <code>AppComponent</code> [angular-reddit/src/app/app.component.ts]:</p>
<pre><code class="ts">  addArticle(title: HTMLInputElement, link: HTMLInputElement): boolean {
    console.log(`Adding article title: ${title.value} and link: ${link.value}`);
    return false;
  }
</code></pre>

<p>Las funciones en <strong>TypeScript</strong> tienen algunas cosas peculiares si venimos de otros lenguajes de programación, el tipo de dato retornado (en este caso <code>boolean</code>) se define después de la cabecera de la función. Ahora mismo si lo probamos no le estamos pasando nada, necesitamos asociar en la plantilla los campos de edición con la llamada a la función.</p>
<pre><code class="ts">&lt;form&gt;
  &lt;h3&gt;Add a Link&lt;/h3&gt;

  &lt;div&gt;
    &lt;label for=&quot;title&quot;&gt;Title:&lt;/label&gt;
    &lt;!-- Cambio #newtitle --&gt;
    &lt;input name=&quot;title&quot; id=&quot;title&quot; #newtitle /&gt;
  &lt;/div&gt;

  &lt;div&gt;
    &lt;label for=&quot;link&quot;&gt;Link:&lt;/label&gt;
    &lt;!-- Cambio #newlink --&gt;
    &lt;input name=&quot;link&quot; id=&quot;link&quot; #newlink /&gt;
  &lt;/div&gt;

  &lt;button (click)=&quot;addArticle(newtitle, newlink)&quot;&gt;Submit link&lt;/button&gt;
&lt;/form&gt;
</code></pre>

<p>Hemos introducido <code>#newtitle</code> con "#" (<em>hash</em>) por delante para crear una referencia a un elemento de la plantilla y pasarlas como parámetro a la función.</p>
<p><code>newtitle</code> es ahora un objeto que representa el elemento DOM de la etiqueta <code>input</code>, de tipo <code>HTMLInputElement</code> concretamente, como es un objeto podemos acceder a su valor usando <code>newtitle.value</code>.</p>
<p>Ejemplo en acción:</p>
<p><img alt="" src="../img/08.PNG" /></p>
<h1 id="anadiendo-el-componente-con-el-articulo">Añadiendo el componente con el artículo</h1>
<p>Vamos a crear un componte para mostrar cada uno de los artículos dados de alta.</p>
<pre><code class="ts">ng generate component article
</code></pre>

<p>Editamos [angular-reddit/src/app/article/article.component.html]:</p>
<pre><code class="ts">&lt;div&gt;
  &lt;div&gt;
    &lt;div&gt;{{ votes }}&lt;/div&gt;
    &lt;div&gt;Points&lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;

&lt;div&gt;
  &lt;a href=&quot;{{ link }}&quot;&gt;{{ title }}&lt;/a&gt;
  &lt;ul&gt;
    &lt;li&gt;
      &lt;a href (click)=&quot;voteUp()&quot;&gt; &lt;i class=&quot;arrow up icon&quot;&gt;&lt;/i&gt;upvote &lt;/a&gt;
    &lt;/li&gt;

    &lt;li&gt;
      &lt;a href (click)=&quot;voteDown()&quot;&gt; &lt;i class=&quot;arrow down icon&quot;&gt;&lt;/i&gt;downvote&lt;/a&gt;
    &lt;/li&gt;
  &lt;/ul&gt;
&lt;/div&gt;
</code></pre>

<p>Ahora editamos el componente [angular-reddit/src/app/article/article.component.ts]:</p>
<pre><code class="ts">  constructor() {
    this.title = &quot;Angular&quot;;
    this.link = &quot;http://angular.io&quot;;
    this.votes = 10;
  }

  voteUp() {
    this.votes += 1;
  }

  voteDown() {
    this.votes -= 1;
  }
</code></pre>

<p>Hemos definido tres atributos para la clase <code>ArticleComponent</code>, el título, el enlace y el número total de votos. También hemos definido dos funciones miembro para sumar o restar votos. Hemos inicializado los atributos de la clase con algunos valores por defecto. Ahora ya podemos ver el formulario el acción y como funciona el <em>data-binding</em>, si sumamos votos o los restamos inmediatamente se visualiza en pantalla.</p>
<p><img alt="" src="../img/09.PNG" /></p>
<p>Ahora cuando pinchamos sobre los enlaces provocan que la página se vuelva a cargar, JS por defecto propaga el evento click a los componentes padre, eso provoca que nuestro navegador trate de seguir un enlace vacío (<code>&lt;a href (click)="voteUp()"&gt;</code>) que le dice al navegador que recargue la página.</p>
<p>Para evitar este efecto tan poco estético necesitamos decirle al manejador del evento que retorn <em>false</em>.</p>
<pre><code class="ts">  voteUp(): boolean {
    this.votes += 1;
    console.log(&quot;voteUp, total:&quot; + this.votes);
    return false;
  }
</code></pre>

<h1 id="renderizando-una-serie-de-articulos">Renderizando una serie de artículos</h1>
<p>Hasta el momento sólo tenemos un artículo y no hay forma de mostrar más excepto que dupliquemos la etiqueta <code>&lt;app-article&gt;</code>.</p>
<h2 id="creando-una-clase-para-los-articulos">Creando una clase para los artículos</h2>
<p>Una buena práctica de programación en Angular es tratar de aislar las estructuras de datos de los componentes. Para ello vamos a crear una clase <code>Article</code> que represente un artículo. Añadimos un nuevo archivo [angular-reddit/src/app/article/article.model.ts]</p>
<pre><code class="ts">export class Article {
  title: string;
  link: string;
  votes: number;

  constructor(title: string, link: string, votes?: number) {
    this.title = title;
    this.link = link;
    this.votes = votes || 0;
  }
}
</code></pre>

<p>Acabamos de crear una clase que representa un artículo, es una clase "plana" y no un componente (el equivalente el modelo en MVC).</p>
<p>El carácter "?" indica que el parámetro <code>votes</code> es opcional (sería 0 en caso de no pasarlo).</p>
<p>Ahora debemos actualizar el componente ArticleComponent para usar nuestra nueva clase Article, en [angular-reddit/src/app/article/article.component.ts] importamos primero la clase.</p>
<pre><code class="ts">import { Article } from &quot;./article.model&quot;;
</code></pre>

<p>Ahora ya podemos usarla:</p>
<pre><code class="ts">export class ArticleComponent implements OnInit {
  article: Article;

  constructor() {
    this.article = new Article(&quot;Angular&quot;, &quot;http://angular.io&quot;, 10);
  }

  voteUp(): boolean {
    this.article.votes += 1;
    return false;
  }

  voteDown(): boolean {
    this.article.votes -= 1;
    return false;
  }

  ngOnInit() {}
}
</code></pre>

<p>Ahora debemos modificar la plantilla para reflejar los cambios:</p>
<pre><code class="ts">&lt;div&gt;
  &lt;div&gt;
    &lt;div&gt;{{ article.votes }}&lt;/div&gt;
    &lt;div&gt;Points&lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;

&lt;div&gt;
  &lt;a href=&quot;{{ article.link }}&quot;&gt;{{ article.title }}&lt;/a&gt;
  &lt;ul&gt;
    &lt;li&gt;
      &lt;a href (click)=&quot;voteUp()&quot;&gt;&lt;i class=&quot;arrow up icon&quot;&gt;&lt;/i&gt;upvote&lt;/a&gt;
    &lt;/li&gt;

    &lt;li&gt;
      &lt;a href (click)=&quot;voteDown()&quot;&gt;&lt;i class=&quot;arrow down icon&quot;&gt;&lt;/i&gt;downvote&lt;/a&gt;
    &lt;/li&gt;
  &lt;/ul&gt;
&lt;/div&gt;
</code></pre>

<p>Las funciones <code>voteUp</code> y <code>voteDown</code> contravienen las normas de la <a href="https://es.wikipedia.org/wiki/Ley_de_Demeter">Ley de Demeter</a> que (o principio de menor conocimiento), en programación orientada a objetos dice que un objeto debería asumir lo menor posible sobre las propiedades de otro objeto o su estructura. Definimos estas mismas funciones en la clase <code>Article</code>:</p>
<pre><code class="ts">export class Article {
  title: string;
  link: string;
  votes: number;

  constructor(title: string, link: string, votes?: number) {
    this.title = title;
    this.link = link;
    this.votes = votes || 0;
  }

  voteUp(): void {
    this.votes += 1;
  }

  voteDown(): void {
    this.votes -= 1;
  }
}
</code></pre>

<p>Ahora desde las funciones <code>voteUp</code> y <code>voteDown</code> de <code>ArticleComponent</code> llamamos a las funciones correspondientes de la clase <code>Article</code>, por ejemplo <code>this.article.voteUp();</code>.</p>
<h1 id="almacenando-mas-de-un-articulo">Almacenando más de un artículo</h1>
<h1 id="codigo-fuente">Código fuente</h1>
<ul>
<li>angular / src / 01-intro / <a href="https://gitlab.com/soka/angular/tree/master/src/01-intro/reddit-clone">reddit-clone</a>. Primera parte del artículo.</li>
</ul>
<h1 id="enlaces-externos">Enlaces externos</h1>
<ul>
<li>Este tutorial está sacado del libro <a href="https://www.ng-book.com/2/">"ng-book: The Complete Book on Angular 7"</a>.</li>
<li><a href="https://www.tutorialspoint.com/typescript/typescript_arrays.htm">"TypeScript Arrays - TutorialsPoint"</a>.</li>
<li><a href="https://victorroblesweb.es/2016/11/07/input-output-angular-2/">"Input y Output en Angular 2 - Victor Robles | Victor Robles"</a>.</li>
<li><a href="https://angular.io/api/core/Input">"Angular - Input"</a>.</li>
<li><a href="https://angular.io/guide/component-interaction">"Angular - Component Interaction"</a>.</li>
<li><a href="https://academia-binaria.com/base-aplicacion-angular/">"Base para una aplicación Angular | Academia Binaria"</a>.</li>
<li>
<p><a href="https://desarrolloweb.com/articulos/trabajar-modulos-angular.html">"Trabajar con módulos en Angular - DesarrolloWeb"</a>.</p>
</li>
<li>
<p>tutorialspoint.com <a href="https://www.tutorialspoint.com/typescript/typescript_functions.htm">"TypeScript - Functions"</a>.</p>
</li>
<li>blog.angulartraining.com <a href="https://blog.angulartraining.com/tutorial-the-magic-of-template-reference-variables-3183f0a0d9d1">"The magic of template reference variables"</a>.</li>
</ul>
<pre><code>
</code></pre>
              
            </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../../ejercicio-gestion-clientes/ejercicio-gestion-clientes/" class="btn btn-neutral float-right" title="Aplicación: Gestión clientes">Next <span class="icon icon-circle-arrow-right"></span></a>
      
      
        <a href="../../todo-aplicacion-lista-tareas/todo-aplicacion-lista-tareas/" class="btn btn-neutral" title="Aplicación lista de tareas"><span class="icon icon-circle-arrow-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
    
  </div>

  Built with <a href="http://www.mkdocs.org">MkDocs</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
      
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" style="cursor: pointer">
    <span class="rst-current-version" data-toggle="rst-current-version">
      
          <a href="https://gitlab.com/soka/angular/" class="icon icon-gitlab" style="float: left; color: #fcfcfc"> GitLab</a>
      
      
        <span><a href="../../todo-aplicacion-lista-tareas/todo-aplicacion-lista-tareas/" style="color: #fcfcfc;">&laquo; Previous</a></span>
      
      
        <span style="margin-left: 15px"><a href="../../ejercicio-gestion-clientes/ejercicio-gestion-clientes/" style="color: #fcfcfc">Next &raquo;</a></span>
      
    </span>
</div>
    <script>var base_url = '../../..';</script>
    <script src="../../../js/theme.js" defer></script>
      <script src="../../../search/main.js" defer></script>

</body>
</html>
